=== debian/changelog ===
libzeem (2.1.2+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Exclude potentially copyrighted test files, skip running tests
  * Symlink jquery.js as provided by its Debian package.
  * Add myself to uploaders

 -- Andrius Merkys <merkys@debian.org>  Fri, 20 Feb 2026 03:25:44 -0500

libzeem (2.0.5-1) unstable; urgency=medium

  * Initial release. Closes: #1121715

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Wed, 03 Dec 2025 09:06:08 +0100
