=== debian/control ===
Source: libzeem
Section: libs
Priority: optional
Maintainer: Maarten L. Hekkelman <maarten@hekkelman.com>
Uploaders:
 Andrius Merkys <merkys@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libmcfp-dev,
 libhowardhinnant-date-dev,
 catch2,
 doxygen,
 python3-exhale,
 python3-sphinx-rtd-theme,
 python3-myst-parser
Standards-Version: 4.7.2
Homepage: https://forge.hekkelman.net/maarten/zeem
Vcs-Git: https://salsa.debian.org/debian/libzeem.git
Vcs-Browser: https://salsa.debian.org/debian/libzeem

Package: libzeem-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 libzeem2 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Suggests: libzeem-doc, mrc
Description: Development files for libzeem
 Libzeem is a complete XML library written in C++. It has a DOM
 interface, a validating parser, DTD support and an implementation
 of XPath 1.0. There is also support for serialization of objects
 using an approach similar to boost::serialization.
 .
 This specific package contains the files you need to develop software
 using libzeem.

Package: libzeem-doc
Section: doc
Architecture: all
Depends:
 libboost-regex-dev,
 zlib1g-dev,
 ${misc:Depends},
 libjs-sphinxdoc,
 libjs-jquery
Description: Documentation files for libzeem
 Libzeem is a complete XML library written in C++. It has a DOM
 interface, a validating parser, DTD support and an implementation
 of XPath 1.0. There is also support for serialization of objects
 using an approach similar to boost::serialization.
 .
 This specific package contains the documentation you can use to develop new
 software using libcifpp.

Package: libzeem2
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Multi-Arch: same
Description: Library file for libzeem
 Libzeem is a complete XML library written in C++. It has a DOM
 interface, a validating parser, DTD support and an implementation
 of XPath 1.0. There is also support for serialization of objects
 using an approach similar to boost::serialization.
 .
 This package contains the library file only.
