=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
# Fixing reproducible builds
LC_ALL := C.UTF-8
export LC_ALL

%:
	dh $@

# Tests are turned off due to excluded test files
override_dh_auto_configure:
	dh_auto_configure -- \
		-DBUILD_SHARED_LIBS=ON \
		-DZEEM_BUILD_DOCUMENTATION=ON \
		-DZEEM_BUILD_EXAMPLES=ON \
		-DBUILD_TESTING=OFF

execute_after_dh_auto_install:
	rm debian/tmp/usr/share/doc/zeem/_static/jquery.js

execute_after_dh_clean:
	rm -rf doc/html doc/mxml/.buildinfo docs/api
