=== debian/tests/control ===
Tests: testcode.sh
Depends: build-essential, libzeem-dev, cmake, libhowardhinnant-date-dev
Restrictions: allow-stderr
