=== debian/watch ===
version=4

opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/libzeem-$1\.tar\.gz/,repack,repacksuffix=+dfsg,dversionmangle=auto \
  https://github.com/mhekkel/zeem/tags .*/v?(\d\S*)\.tar\.gz
